/*
  a nicer widget for the timer.The default yaf widget are (supposed) to be ugly
  Copyright (C) 1998  Martin Vogt

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation.

  For more information look at the file COPYRIGHT in this package

 */




#include "timerWidget.h"



TimerWidget::TimerWidget( QWidget *parent=0, const char *name=0 ):
             GuiTimerDevice( parent, name ) {

  led=new LED();
  setMinimumSize( sizeHint() );
  setMaximumSize( sizeHint() );

}


TimerWidget::~TimerWidget() {
  delete led;
}


QSize TimerWidget::sizeHint () {
  int w;
  int h;
  QPixmap* pixmap=led->getPixmap(_LED_DIGIT_8);
  w=pixmap->size().width();
  h=pixmap->size().height();
  QSize size(w*4+w/2,h);
  return size;
}


void TimerWidget::paintEvent ( QPaintEvent * paintEvent ) {
  int time;
  int min;
  int sec;
  QPixmap* pixmapCurrent;
  int nWidth=0;
  int nHeight=0;
  int tmp;

  time=(int)getTime();
  min=time/60;
  sec=time%60;
 
  QPainter paint;
  paint.begin( this );

  // draw the 10'th minutes

  if (min < 10) {
    pixmapCurrent=led->getPixmap(_LED_BLANK);
  } else {
    tmp=min/10;

    // display overeflow....?
    if (tmp > 9) {
      tmp=9;
    }
    pixmapCurrent=led->getPixmap(tmp);
  }
  paint.drawPixmap(nWidth, nHeight, *pixmapCurrent);
  nWidth=nWidth+pixmapCurrent->width();

  // draw single minutes
  min=min%10;
  pixmapCurrent=led->getPixmap(min);
  paint.drawPixmap ( nWidth, nHeight, *pixmapCurrent);
  nWidth=nWidth+pixmapCurrent->width();

  // draw dots
  // why must I substract 2 ??
  pixmapCurrent=led->getPixmap(_LED_DOTS);
  paint.drawPixmap ( nWidth, nHeight, *pixmapCurrent);
  nWidth=nWidth+pixmapCurrent->width();

  
  // draw seconds
  tmp=sec/10;
  pixmapCurrent=led->getPixmap(tmp);
  paint.drawPixmap ( nWidth, nHeight, *pixmapCurrent);
  nWidth=nWidth+pixmapCurrent->width();
  
  // draw seconds
  tmp=sec%10;
  pixmapCurrent=led->getPixmap(tmp);
  paint.drawPixmap ( nWidth, nHeight, *pixmapCurrent);
  nWidth=nWidth+pixmapCurrent->width();
 

  paint.end();  
  

}


 
