#include "mpegsound.h"
#include "splay.h"
#include <string.h>
#include <sys/stat.h>
#include <math.h>
#include "../common.h"
#include <iostream.h>
#include "rawtoemusic.h"
#include <pthread.h>

Soundinputstream *loader = NULL;
Rawtoemusic	 *player = NULL;
Mpegtoraw	 *server = NULL;

char *song_path;

int pcmperframe, frequency, maxframes;
int wait_for_me=0;
int lRun;
int downSampleFlag=0;
int monoFlag=0;


extern int end_of_song;
extern int end_song;
extern int stop_song;
extern pthread_t player_thread;
extern pthread_mutex_t player_lock;

void sseek_to_frame(int second)
{
   int frame;
   while (wait_for_me)
      usleep(100);
   frame = second * frequency / pcmperframe;
   server->clearbuffer();
   server->setframe(frame);
}

void *mp3_thread(int *foo) {
  int start = 0;
  if (foo)
    start = *foo;

  player = new Rawtoemusic;
  player->initialize(NULL);

  server = new Mpegtoraw(loader, player);
  server->initialize(song_path);

  server->setdownfrequency(downSampleFlag);
  server->setforcetomono(monoFlag);
  server->run(-1);

  frequency = server->getfrequency();
  pcmperframe = server->getpcmperframe();

  //   if (start)
  // server->setframe(start * frequency / pcmperframe); 
  wait_for_me = 0;
  pthread_setcancelstate(PTHREAD_CANCEL_ENABLE, NULL);
  pthread_setcanceltype(PTHREAD_CANCEL_DEFERRED, NULL);
  while(lRun) {
    pthread_mutex_lock(&player_lock);
    if (lRun == false) {
      pthread_mutex_unlock(&player_lock);
      break;
    }
    
    if (!server->run(5) && (server->geterrorcode() == SOUND_ERROR_FINISH)) {
      end_song = 1;
      pthread_mutex_unlock(&player_lock);
      server->clearbuffer();
      while (lRun) {
	pthread_testcancel();
	usleep(500);
      }
      break;
    }
    pthread_mutex_unlock(&player_lock);
    pthread_testcancel();
  }
  return NULL;
}

int splay(int start, char *path)
{
  float bug=pow(6.0,3.0);            // fixes bug in __math.h
  int err;
  end_of_song = 0;
  loader = Soundinputstream::hopen(path, &err);
  if (!loader)
    return 0;
  song_path = path;
  wait_for_me = 1;
  lRun=true;
  pthread_create(&player_thread, NULL, mp3_thread, (void *)&start);
  return 1; 
}

void spause_it(void)
{
}

void sstop(int playing)
{
   while (wait_for_me)
      usleep(100);
   lRun=false;
   pthread_mutex_unlock(&player_lock);
   pthread_join(player_thread, NULL);
   
   if (!server)
      return;
   server->clearbuffer();
   player->abort();
   player->resetsoundtype();
   delete server;
   delete player;
   delete loader;
   server = NULL;
}

int sis_file(char *path)
{
   char *temp;
   if (!path)
      return 0;
   if ((temp = strrchr(path, '.')) && (temp+3)) {
      if (!strcasecmp((temp+1),"mp3")) 
         return 1;
      if (!strcasecmp((temp+1),"mpg")) 
         return 1;
   }
   return 0;
}

void sversion_info(char *id, char *version, char *copyright)
{
   strcpy(id, "splay");
   strcpy(version, "0.8.2");
   strcpy(copyright, "1998 Woo-jae Jung");
}

void sinit(void)
{
}

void sget_info(struct playlist_item *song)
{
   float len;
   struct stat mp3stat;
   stat(song->path, &mp3stat);
   len = mp3stat.st_size / 418.12;
   len = (int)(len / 16) * 16;
   song->length = (int)(rint(len/38.28));
   song->tag.genre = -1;
   if (song->tag.genre == -1)
      strcpy(song->name, strrchr(song->path,'/') + 1);
   else
      strcpy(song->name, song->tag.song);
}

void sconfig(char *left, char *right) {
  if (strcmp(left,"-m")==0) {
    monoFlag=true;
  }
  if (strcmp(left,"-2")==0) {
    downSampleFlag=true;
  }
  
}
