/*
  device print the time of the stream which was actually written
  Copyright (C) 1998  Martin Vogt

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation.

  For more information look at the file COPYRIGHT in this package

 */




#include <devices/timerDevice.h>

static int instance=0;

TimerDevice::TimerDevice() {
  time=0.0;
  bytes=0;
  instanceCnt=instance;
  instance++;
}


TimerDevice::~TimerDevice() {
}



char* TimerDevice::getNodeName() {
  return "TimerDevice";
}


float TimerDevice::getTime() {
  return time;
}

int TimerDevice::getBytes() {
  return bytes;
}


void TimerDevice::writeIn(NodeDevice* source,DeviceConfig* buf) {
  YafAudioInfo* info=buf->getAudioInfo();
  StatusInfo* statusInfo=buf->getStatusInfo();

 
  if (statusInfo->getStatus() == _STATUS_PLAYING) {
    time=info->getTime();
    bytes=info->getPlayedBytes();
  }

}
  
 




